RegionMXBean (Apache Geode 1.15.4)

org.apache.geode.management

## Interface RegionMXBean

-     public interface RegionMXBean

  MBean that provides access to information and management functionality for a local `Region`. For all the latency related attributes e.g. PutRemoteLatency ,DiskWritesAverageLatency etc.. "enable-time-statistics" should be set to true.
  Since:
    GemFire 7.0

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getActualRedundancy()` Returns the actual number of redundant copies available for buckets in this partitioned region.
    `float` | `getAverageReads()` Returns the average number of read requests per second.
    `float` | `getAverageWrites()` Returns the average number of write requests per second.
    `int` | `getAvgBucketSize()` Deprecated. This attribute is removed from 8.0 for being incorrect and impacting performance.
    `int` | `getBucketCount()` Returns the number of buckets on this member.
    `long` | `getCacheListenerCallsAvgLatency()` Returns the average latency of a call to a `CacheListener` in nanoseconds.
    `long` | `getCacheWriterCallsAvgLatency()` Returns the average latency of a call to a `CacheWriter` in nanoseconds.
    `int` | `getConfiguredRedundancy()` Returns the number of redundant copies configured for this partitioned region.
    `float` | `getCreatesRate()` Returns the number of creates per second.
    `float` | `getDestroyRate()` Returns the number of destroys per second.
    `long` | `getDiskReadsAverageLatency()` Deprecated. See corresponding DiskStores latency to get the latency.
    `float` | `getDiskReadsRate()` Returns the number of entries reads per second from disk.
    `long` | `getDiskTaskWaiting()` Deprecated.
    `long` | `getDiskUsage()` Returns the total number of bytes stored in disk for this region.
    `long` | `getDiskWritesAverageLatency()` Deprecated. See corresponding DiskStores latency to get the latency.
    `float` | `getDiskWritesRate()` Returns the number of entries written per second to disk.
    `long` | `getEntryCount()` Returns the number of entries in the Region within this member.
    `long` | `getEntrySize()` Returns the aggregate entry size (in bytes) of all entries.
    `String` | `getFullPath()` Returns the full path of the Region.
    `float` | `getGetsRate()` Returns the number of gets per second.
    `long` | `getHitCount()` Returns the number of times that a hit occurred.
    `float` | `getHitRatio()` Returns the hit to miss ratio.
    `long` | `getLastAccessedTime()` Returns the time of the most recent access.
    `long` | `getLastModifiedTime()` Returns the time of the most recent modification.
    `int` | `getLocalMaxMemory()` Returns the maximum amount of local memory that can be used by the region.
    `float` | `getLruDestroyRate()` Returns the rate of entries destroyed either by destroy cache operations or eviction.
    `float` | `getLruEvictionRate()` Returns the entry eviction rate as triggered by the LRU policy.
    `String` | `getMember()` Returns the name/ID of the member hosting this Region.
    `long` | `getMissCount()` Returns the number of times that a cache miss occurred.
    `String` | `getName()` Returns the name of the Region.
    `int` | `getNumBucketsWithoutRedundancy()` Returns the number of buckets without full redundancy.
    `String` | `getParentRegion()` The name of the parent Region or `null` if the Region has no parent.
    `int` | `getPrimaryBucketCount()` Returns the number of primary buckets on this member.
    `float` | `getPutAllRate()` Returns the number of putAlls per second.
    `float` | `getPutLocalRate()` Returns the number of local puts per second.
    `long` | `getPutRemoteAvgLatency()` Returns the average latency for remote puts in nanoseconds.
    `long` | `getPutRemoteLatency()` Returns the latency for the most recent remote put in nanoseconds.
    `float` | `getPutRemoteRate()` Returns the number of remote puts per second.
    `float` | `getPutsRate()` Returns the number of puts per second.
    `String` | `getRegionType()` Returns the type (data policy) of the Region.
    `int` | `getTotalBucketSize()` Returns the total number of entries in all buckets.
    `long` | `getTotalDiskEntriesInVM()` Returns the current number of entries held in memory.
    `long` | `getTotalDiskWritesProgress()` Returns the current number of disk writes in progress.
    `long` | `getTotalEntriesOnlyOnDisk()` Returns the current number of entries whose values are only on disk (not in memory).
    `boolean` | `isGatewayEnabled()` Returns whether this region sends data using a GatewaySender.
    `boolean` | `isPersistentEnabled()` Returns whether persistence is enabled.
    `EvictionAttributesData` | `listEvictionAttributes()` Returns the eviction attributes of the Region.
    `FixedPartitionAttributesData[]` | `listFixedPartitionAttributes()` Returns the fixed partition attributes of the Region.
    `MembershipAttributesData` | `listMembershipAttributes()` Deprecated. this API is scheduled to be removed
    `PartitionAttributesData` | `listPartitionAttributes()` Returns the partition attributes of the Region.
    `RegionAttributesData` | `listRegionAttributes()` Returns the attributes of the Region.
    `String[]` | `listSubregionPaths(boolean recursive)` Returns a list of the names of the sub regions.

- - ### Method Detail

    - #### getName

          String getName()

      Returns the name of the Region.
      Returns:
        the name of the Region

    - #### getRegionType

          String getRegionType()

      Returns the type (data policy) of the Region.
      Returns:
        the type (data policy) of the Region

    - #### getFullPath

          String getFullPath()

      Returns the full path of the Region.
      Returns:
        the full path of the Region

    - #### getParentRegion

          String getParentRegion()

      The name of the parent Region or `null` if the Region has no parent.
      Returns:
        name of the parent Region or `null` if the Region has no parent

    - #### listSubregionPaths

          String[] listSubregionPaths(boolean recursive)

      Returns a list of the names of the sub regions.
      Parameters:
        `recursive` - `True` to recursively traverse and find sub-regions.
      Returns:
        a list of the names of the sub regions

    - #### listRegionAttributes

          RegionAttributesData listRegionAttributes()

      Returns the attributes of the Region.
      Returns:
        the attributes of the Region

    - #### listPartitionAttributes

          PartitionAttributesData listPartitionAttributes()

      Returns the partition attributes of the Region.
      Returns:
        the partition attributes of the Region

    - #### listFixedPartitionAttributes

          FixedPartitionAttributesData[] listFixedPartitionAttributes()

      Returns the fixed partition attributes of the Region.
      Returns:
        the fixed partition attributes of the Region

    - #### listEvictionAttributes

          EvictionAttributesData listEvictionAttributes()

      Returns the eviction attributes of the Region.
      Returns:
        the eviction attributes of the Region

    - #### listMembershipAttributes

          @Deprecated
          MembershipAttributesData listMembershipAttributes()

      Deprecated. this API is scheduled to be removed
      Returns the membership attributes of the Region.
      Returns:
        the membership attributes of the Region

    - #### getLastModifiedTime

          long getLastModifiedTime()

      Returns the time of the most recent modification. For partitioned region it will be -1 . This feature is not supported for partitioned regions.
      Returns:
        the time of the most recent modification

    - #### getLastAccessedTime

          long getLastAccessedTime()

      Returns the time of the most recent access. For partitioned region it will be -1. This feature is not supported for partitioned regions.
      Returns:
        the time of the most recent access

    - #### getMissCount

          long getMissCount()

      Returns the number of times that a cache miss occurred. For partitioned region it will be -1 . This feature is not supported for partitioned regions.
      Returns:
        the number of times that a cache miss occurred

    - #### getHitCount

          long getHitCount()

      Returns the number of times that a hit occurred. For partitioned region it will be -1.This feature is not supported for partitioned regions.
      Returns:
        the number of times that a hit occurred

    - #### getHitRatio

          float getHitRatio()

      Returns the hit to miss ratio. For partitioned region it will be -1 .This feature is not supported for partitioned regions.
      Returns:
        the hit to miss ratio

    - #### getEntryCount

          long getEntryCount()

      Returns the number of entries in the Region within this member. For partitioned regions it will be the entry count for the primary buckets hosted within this member.
      Returns:
        the number of entries in the Region within this member

    - #### getGetsRate

          float getGetsRate()

      Returns the number of gets per second.
      Returns:
        the number of gets per second

    - #### getPutsRate

          float getPutsRate()

      Returns the number of puts per second.
      Returns:
        the number of puts per second

    - #### getCreatesRate

          float getCreatesRate()

      Returns the number of creates per second.
      Returns:
        the number of creates per second

    - #### getDestroyRate

          float getDestroyRate()

      Returns the number of destroys per second.
      Returns:
        the number of destroys per second

    - #### getPutAllRate

          float getPutAllRate()

      Returns the number of putAlls per second.
      Returns:
        the number of putAlls per second

    - #### getPutLocalRate

          float getPutLocalRate()

      Returns the number of local puts per second. Only applicable for partitioned regions.
      Returns:
        the number of local puts per second

    - #### getPutRemoteRate

          float getPutRemoteRate()

      Returns the number of remote puts per second. Only applicable for partitioned regions.
      Returns:
        the number of remote puts per second

    - #### getPutRemoteLatency

          long getPutRemoteLatency()

      Returns the latency for the most recent remote put in nanoseconds. Only applicable for partitioned regions.
      Returns:
        the latency for the most recent remote put in nanoseconds

    - #### getPutRemoteAvgLatency

          long getPutRemoteAvgLatency()

      Returns the average latency for remote puts in nanoseconds. Only applicable for partitioned regions.
      Returns:
        the average latency for remote puts in nanoseconds

    - #### getTotalEntriesOnlyOnDisk

          long getTotalEntriesOnlyOnDisk()

      Returns the current number of entries whose values are only on disk (not in memory). Entries may not exist in memory if they have been overflowed to disk or not yet been faulted in after a recovery.
      Returns:
        the current number of entries whose values are only on disk

    - #### getTotalDiskEntriesInVM

          long getTotalDiskEntriesInVM()

      Returns the current number of entries held in memory.
      Returns:
        the current number of entries held in memory

    - #### getDiskReadsRate

          float getDiskReadsRate()

      Returns the number of entries reads per second from disk.
      Returns:
        the number of entries reads per second from disk

    - #### getDiskReadsAverageLatency

          @Deprecated
          long getDiskReadsAverageLatency()

      Deprecated. See corresponding DiskStores latency to get the latency.
      Returns the average latency of disk reads in nanoseconds
      Returns:
        the average latency of disk reads in nanoseconds

    - #### getDiskWritesAverageLatency

          @Deprecated
          long getDiskWritesAverageLatency()

      Deprecated. See corresponding DiskStores latency to get the latency.
      Returns the average latency of disk writes in nanoseconds.
      Returns:
        the average latency of disk writes in nanoseconds

    - #### getDiskWritesRate

          float getDiskWritesRate()

      Returns the number of entries written per second to disk.
      Returns:
        the number of entries written per second to disk

    - #### getTotalDiskWritesProgress

          long getTotalDiskWritesProgress()

      Returns the current number of disk writes in progress.
      Returns:
        the current number of disk writes in progress

    - #### getDiskTaskWaiting

          @Deprecated
          long getDiskTaskWaiting()

      Deprecated.
      Returns the current number of disk tasks (op-log compaction, asynchronous recoveries, etc) that are waiting for a thread to run.
      Returns:
        the current number of disk tasks that are waiting for a thread to run

    - #### getCacheWriterCallsAvgLatency

          long getCacheWriterCallsAvgLatency()

      Returns the average latency of a call to a `CacheWriter` in nanoseconds.
      Returns:
        the average latency of a call to a `CacheWriter` in nanoseconds

    - #### getCacheListenerCallsAvgLatency

          long getCacheListenerCallsAvgLatency()

      Returns the average latency of a call to a `CacheListener` in nanoseconds.
      Returns:
        the average latency of a call to a `CacheListener` in nanoseconds

    - #### getLruEvictionRate

          float getLruEvictionRate()

      Returns the entry eviction rate as triggered by the LRU policy.
      Returns:
        the entry eviction rate as triggered by the LRU policy

    - #### getLruDestroyRate

          float getLruDestroyRate()

      Returns the rate of entries destroyed either by destroy cache operations or eviction.
      Returns:
        the rate of entries destroyed either by destroy cache operations or eviction

    - #### getBucketCount

          int getBucketCount()

      Returns the number of buckets on this member. Only applicable for partitioned regions.
      Returns:
        the number of buckets on this member

    - #### getPrimaryBucketCount

          int getPrimaryBucketCount()

      Returns the number of primary buckets on this member. Only applicable for partitioned regions.
      Returns:
        the number of primary buckets on this member

    - #### getNumBucketsWithoutRedundancy

          int getNumBucketsWithoutRedundancy()

      Returns the number of buckets without full redundancy. Only applicable for partitioned regions.
      Returns:
        the number of buckets without full redundancy

    - #### getConfiguredRedundancy

          int getConfiguredRedundancy()

      Returns the number of redundant copies configured for this partitioned region. Only applicable for partitioned regions.
      Returns:
        the number of redundant copies configured for this partitioned region

    - #### getActualRedundancy

          int getActualRedundancy()

      Returns the actual number of redundant copies available for buckets in this partitioned region. Usually this is the number of redundant copies configured for buckets in the region. However, during initialization or error states the actual number of copies for any given bucket may be less than the configured number. In that case, the value returned will be the smallest number of redundant copies available for any single bucket.
      Returns:
        the actual number of redundant copies available for buckets in this partitioned region

    - #### getTotalBucketSize

          int getTotalBucketSize()

      Returns the total number of entries in all buckets. Only applicable for partitioned regions.
      Returns:
        the total number of entries in all buckets

    - #### getAvgBucketSize

          @Deprecated
          int getAvgBucketSize()

      Deprecated. This attribute is removed from 8.0 for being incorrect and impacting performance.
      Returns the average number of entries in bucket. Only applicable for partitioned regions.
      Returns:
        the average number of entries in bucket

    - #### getDiskUsage

          long getDiskUsage()

      Returns the total number of bytes stored in disk for this region.
      Returns:
        the total number of bytes stored in disk for this region

    - #### getEntrySize

          long getEntrySize()

      Returns the aggregate entry size (in bytes) of all entries. For replicated regions, provides a value only if the eviction algorithm is set to `EvictionAlgorithm.LRU_MEMORY`. All partitioned regions can report entry size, but the value also includes redundant entries and also counts the size of all the secondary entries in the node.
      Returns:
        total entry size in bytes, -1 for replicated regions without LRU_MEMORY eviction

    - #### isGatewayEnabled

          boolean isGatewayEnabled()

      Returns whether this region sends data using a GatewaySender.
      Returns:
        whether this region sends data using a GatewaySender

    - #### getAverageReads

          float getAverageReads()

      Returns the average number of read requests per second.
      Returns:
        the average number of read requests per second

    - #### getAverageWrites

          float getAverageWrites()

      Returns the average number of write requests per second. This includes rates of put, putAll & create operations on the region
      Returns:
        the average number of write requests per second

    - #### isPersistentEnabled

          boolean isPersistentEnabled()

      Returns whether persistence is enabled.
      Returns:
        whether persistence is enabled

    - #### getMember

          String getMember()

      Returns the name/ID of the member hosting this Region.
      Returns:
        the name/ID of the member hosting this Region

    - #### getLocalMaxMemory

          int getLocalMaxMemory()

      Returns the maximum amount of local memory that can be used by the region. This attribute is applicable for PartitionedRegion only. For other regions it will be -1
      Returns:
        the maximum amount of local memory that can be used by the region